////////////////////////////////////////////////////////////////////////////////
// MAIN.C - Dunjon II  by Ghislain De Blois  Remake by Athlor  athlor@gmail.com
////////////////////////////////////////////////////////////////////////////////
#include <pager.h>    // 2003 Minigame comp
#include <ribbon.h>   // CLEAN UP CODE !!!
#include "icon.h"
#include "dunjon.h"   // Monster & Spell names

char VersionPtr[] = "DunjonII";
int AppStackSize = 3000;
int A[17];     // 0-16  (r = a[17]  l = a[18])
char buf[150]; // Buffer for RimSprintf
int r = 537, l = 1, w, x; // Room & level, w=txt win tog, x=all purpose

int fnd(int x) {
  srand(l*10000+x);
  return (rand() % 127) +1; // Dungeon corrupts if changed
} // DEF FN D(X)=INT(RND(-A(17)-A(18)*10000+X))+INT(RND(1)*63+1)

int fnr(int x) {
  RimSleep(2);   // Required because of reseeding method
  srand(RimGetTicks());
  return (rand() % x) +1;
} // DEF FN R(X)=INT(RND(-TI))+INT(RND(1)*X+1)

int fnb(int x) {
  return -(A[x]<4)-(A[x]<6)-(A[x]<9)+(A[x]>12)+(A[x]>15)+(A[x]>17); // Bonus modifier
} // DEF FN B(X)=(A(X)<4)+(A(X)<6)+(A(X)<9)-(A(X)>12)-(A(X)>15)-(A(X)>17)

int key(void) {
  MESSAGE MSG;
  while(RimGetMessage(&MSG), MSG.Event!=KEY_DOWN);
  return MSG.SubMsg;
}

void wall(int x, int y) {
  int i, j;
  for(j = 0; j < 2; j++)
    for(i = 0; i < 3; i++) // Draw 3x2 brick area
      LcdCopyBitmapToDisplay(&IconBMP, x + i * 16, y + j * 16);
}

void stats(char *s) {
  LcdSetTextWindow(0, 0, 160, 160); LcdClearDisplay();
  RimSprintf(buf, 149, "Str: %d\nInt: %d\nWis: %d\nDex: %d\nCon: %d\nCha: %d\nLevel:\
 %d/%d\nExp: %d\nGold: %d\nHP: %d/%d\nSU: %d/%d\nSword +%d\nArmor +%d\nShield +%d\nPotions %d\n\n",
 A[0],A[1],A[2],A[3],A[4],A[5],A[15],l,A[16],A[13],A[7],A[6],A[9],A[8],A[10],A[11],A[12],A[14]);
  LcdPutStringXY(0, 16, buf, -1, LCD_MULTILINE);
  LcdPutStringXY(-1, 152, s, -1, LCD_CENTERED); w = 1;
}

void print(char *s) {
  LcdSetTextWindow(3, 102, 154, 56);
  LcdScroll(8);
  LcdPutStringXY(0, 48, s, -1, 0);
}

void Rstr(void) {
  A[7]=A[6]; // Restore HP
  A[9]=A[8]; // Restore SU
}

void AddX(int x) {
  A[16] += x; // A[16]=A[16]+x;
  RimSprintf(buf, 127, "+%d Exp", x);
  print(buf);
  if (A[16] >= (2<<A[15])*1000) { // ORG A[16] >= 2^(A[15]*1000)
    print("You go up a level!");
    A[15]++;                   // Plr lvl
    A[6]=A[6]+3+fnr(7)+fnb(4); // HP max  +Con
    A[8]++;                    // SU
    Rstr();
  }
}

void Cure(int x) {
  print("You feel better!");
  A[7] += x; // A[7]=A[7]+x;
  if (A[7]>A[6])  A[7]=A[6];
}

int Cmd(void) {
  int z;
  print("Command >");
  z = key();
  if(z=='p' && A[14]>0) { // Potion
    A[14]=A[14]-1;
    Cure(fnr(10)+3);
  }
  x = z-48;
  if (x>0 && x<6 && x <= A[9]) {
    A[9]=A[9]-x;
    RimSprintf(buf, 127, "Cast: %s", magic[x-1]);
    print(buf); RimSpeakerBeep(500+x*50, 50, 50, 50);
    if (x==1)  Cure(fnr(A[1]*2)); // Calc for Cure Wounds  INT
    if (x==4)  Cure(A[6]);        // Calc for Restoration
    if (x==2 || x==3 || x==5) {
      x=fnr((2<<(x-1))*A[1]); // WAS ((x-1)^2*A[1])  STR
      return z; // Calc atk pwr for Magic Missile, Fireball & Finger of Death
    }
  }
  x = 0;
  return z;
}

void vibe(int x) {
  AlertConfiguration VIB = {
   50, 1, 1, 1, x, CONTINUOUS_VIBRATE, VIBRATE_ALERT, VIBRATE_ALERT, 0};
  RimTestAlert(TONE_SEQUENCE_1,&VIB);
}

///////////////////////////////////////////////////////////////////////////////
void D2Thread(void) { /////////////////////////////////////////////////////////
  PID pid;
  pid.Name = VersionPtr;
  pid.EnableForeground = TRUE;
  pid.Icon = NULL;
  RimSetPID(&pid);
  char a=0, b=0, c=0, d=0, e=0, f=0, g, k, m; // g=escape

  LcdClearDisplay(); 
  LcdPutStringXY(-1, 60, "DUNJON II\n\nby Ghislain De Blois\n\n", -1, LCD_CENTERED|LCD_MULTILINE);
  key();  // Wait for any key
  do {    // Character generator
    for (x=0; x<6; x++)
      A[x] = fnr(6)+fnr(6)+fnr(6);
    A[6]=10+fnb(4); // +CON
    A[8]=3+fnb(1);  // +INT
    A[10]=fnr(2)-1;
    A[14]=fnr(3)-1;
    A[15]=1;
    Rstr();
    stats("Keep (y/n)?");
  } while (key() != 'y');

  for (;;) { // MAIN GAME LOOP
    g = 0;   // Clear escape toogle
    if (w) {
      LcdSetTextWindow(0, 0, 160, 160); LcdClearDisplay(); // Text window
      LcdDrawBox(DRAW_BLACK,0,100,159,159); w = 0; // Text window frame
    }
    LcdSetTextWindow(0, 0, 160, 100); LcdClearDisplay(); // Graphic window
    if (l) {
      a = (fnd(r)&2)==2;         // A=A(17)>100  AND (FND(100) AND 2)=2  N
      b = (fnd(r+100)&2)==2;     // B=A(17)<9900 AND (FND(0) AND 2)=2    S
      c = (fnd(r)&1)==1;         // C=A(17)>1    AND (FND(1) AND 1)=1    W
      d = (fnd(r+1)&1)==1;       // D=A(17)<9999 AND (FND(0) AND 1)=1    E
      e = (fnd(r)&28)==28;       // E=(FND(10000) AND 60)=60  D 00111 = 28
      f = (fnd(r+10000)&28)==28; // F=(FND(0) AND 60)=60      U 
      LcdDrawBox(DRAW_BLACK,7,0,152,97);  // Draw frame
      LcdPutStringXY(76, 45, "@", -1, 0); // Draw player
      wall(8, 1); wall(104, 1); wall(8, 65); wall(104, 65); // Draw NW NE SW SE
      if (a)  wall(56,   1); // N
      if (b)  wall(56,  65); // S
      if (c)  wall( 8,  33); // W
      if (d)  wall(104, 33); // E
      if (e)  LcdPutStringXY(77, 33, "#", -1, 0); // UP
      if (f)  LcdPutStringXY(77, 56, "#", -1, 0); // DOWN
    } else {
      print("Welcome to the Inn.");
      print("You cash in your gold.");
      AddX(A[13]); // Cash in gold for Exp
      A[13] = 0;
      print("You rest for the night.");
      Rstr();      // Restore HP SU
      key(); l = 1; continue; // Jump to top of for-loop
    }
    if (fnr(6) > 1) {
      switch (Cmd()) {
        case 'q': if (!a)  r -= 100; break; // NORTH
        case 'z': if (!b)  r += 100; break; // SOUTH
        case 'a': if (!c)  r--; break; // WEST
        case 's': if (!d)  r++; break; // EAST
        case 'u': if (e)   l--; break; // UP
        case 'd': if (f)   l++; break; // DOWN
        case ' ': stats("Press any key"); key(); break; // Show Stats
        case KEY_ESCAPE: // ESC key exits
          RibbonShowRibbon();
          RimTerminateThread(); // EXIT
      } // End switch
      continue;
    }
    RimSpeakerBeep(220, 50, 50, 50); // Monster snd
    m = fnr(6+l)-1; if (m > 19)  m = 19;
    LcdPutStringXY(64, 34, &mon[m][0], 1, 0); // Draw monster
    print("An Encounter!");
    c = fnr((2<<(m/4)) * 8); // WAS 2^(m/4)*8  Monster HP
    if (fnr(200) < A[5]) {   // Check CHA
      print("It likes you!"); m = 80; goto Item; // BAD
    }
    if ((m==8 || m==3) && fnr(20) > A[3]) { // Hobbit or Elf, check DEX 
       print("It steals from you!");
       A[9+fnr(5)]=0;     // Sword, armor, shield, gold or potions
    }
    if (fnr(20) > A[3]) { // Initiative check, DEX
       goto mAtk;         // Monster attack
    }
    do { // COMBAT LOOP
      RimSprintf(buf, 127, "You vs %s (%d)", mon[m],c);
      print(buf);
      RimSprintf(buf, 127, "You have %d hp", A[7]);
      print(buf);
      k = Cmd();
      if (k == 'e') {
        print("Escape");
        g = 0;               // Clear escape toggle
        if (fnr(20) <= A[3]) // Check DEX
          {g = 1; break;}    // Set escape toggle & break loop
        else
          goto mAtk;         // Monster attack
      }
      if (k == 'a') {
        print("Attack");
        x = fnr(10)+3+fnb(0)-A[10];    // Check SWO +STR
        if (fnr(20)+fnb(0) < 9+m/5) {  // +STR
          print("You miss");
          goto mAtk; // Monster attack
        }
      }
      c -= x; // c=c-x;
      if (x > 0) {
        RimSpeakerBeep(440, 50, 50, 50);
        RimSprintf(buf, 127, "You do %d damage", x);
        print(buf);
      }
mAtk:
      if (c > 0) {
        if (m==19 && fnr(20) > A[3]) { // Check DEX
          print("It breathes fire!");
//        a=h;       // Unused artifact of code (in original)
          goto pHit; //'Player hit
        }
        a = fnr(6*(1+m/5));
        if (fnr(20) < 10+A[11]+A[12]) { // Check ARM & SHI
          print("It misses");
          continue;
        }
pHit:
        RimSprintf(buf, 127, "It does %d damage", a);
        print(buf); vibe(m);
        A[7] -= a; // A[7]=A[7]-a
        if(A[7] < 1) {
          vibe(10);
          print("YOU DIED!"); key();
          stats("Any Key Exits"); key();
          RibbonShowRibbon();
          RimTerminateThread(); // EXIT
        }
      }
    } while (c > 0);    // End combat loop
    if (g)  continue;   // Escape
    print("It died");
    AddX((2<<m) * 50);  // Org X=INT(1.5^M*50)
    m += 2;             // m = m + 2;
    if (fnr(30) < m) {
       A[13] += fnr(x); // A[13]=A[13]+fnr(x)
       print("+gold");
    } else {
Item:
      if (fnr(99) < m) {
        b = fnr(3);
        if (A[9+b] * (b>1) > 4) { // << Pos logic prob  WAS A[9+b]*(b>1) > -4
          A[9+b]++;               // A[9+b]=A[9+b]+1;  Sword, Armor or Shield
          print("+item");
        }
      }
      if (fnr(99) < m) {
        A[14]++;  // A[14]=A[14]+1;
        print("+potion");
      }
    }
  } // END MAIN GAME LOOP
}

void PagerMain(void) {
  RibbonRegisterFunction(VersionPtr, &IconBMP, 0, 40, D2Thread, AppStackSize);
}
/*  (Debugging code)
    RimSprintf(buf, 127, "r:%d l:%d ", r, l);
    LcdPutStringXY(110, 99, buf, -1, 0);
    RimSprintf(buf, 127, "a:%d b:%d c:%d d:%d e:%d f:%d ", a, b, c, d, e, f);
    LcdPutStringXY(0, 152, buf, -1, 0);
*/
